use diesel::r2d2::ConnectionManager;
use diesel::result::Error;
use diesel::{pg::PgConnection, r2d2};
use lazy_static::lazy_static;

type Pool = r2d2::Pool<ConnectionManager<PgConnection>>;
pub type DbConnection = r2d2::PooledConnection<ConnectionManager<PgConnection>>;

const DATABASE_URL: &str = "postgres://postgres:root@127.0.0.1/vybr";

lazy_static! {
    static ref POOL: Pool = {
        let manager = ConnectionManager::<PgConnection>::new(DATABASE_URL);
        Pool::new(manager).expect("Failed to create db pool.")
    };
}

pub fn init() {
    log::info!("Initializing db pool.");
    lazy_static::initialize(&POOL);
    let _conn = connection().expect("Failed to get db connection.");
}

pub fn connection() -> Result<DbConnection, Error> {
    POOL.get()
        .map_err(|e| panic!("Database connection error: {}", e))
}
