// @generated automatically by Diesel CLI.

diesel::table! {
    artists (id) {
        #[max_length = 24]
        id -> Varchar,
        #[max_length = 255]
        name -> Varchar,
        slug -> Varchar,
        created_at -> Nullable<Timestamp>,
        updated_at -> Nullable<Timestamp>,
        #[max_length = 22]
        spotify_id -> Nullable<Varchar>,
        #[max_length = 10]
        tidal_id -> Nullable<Varchar>,
    }
}

diesel::table! {
    artists_tracks (artist_id, track_id) {
        #[max_length = 24]
        artist_id -> Varchar,
        #[max_length = 24]
        track_id -> Varchar,
    }
}

diesel::table! {
    playlists (id) {
        #[max_length = 24]
        id -> Varchar,
        #[max_length = 255]
        name -> Varchar,
        public -> Bool,
        #[max_length = 24]
        creator_id -> Varchar,
        created_at -> Nullable<Timestamp>,
        updated_at -> Nullable<Timestamp>,
    }
}

diesel::table! {
    playlists_tracks (playlist_id, track_id) {
        #[max_length = 24]
        playlist_id -> Varchar,
        #[max_length = 24]
        track_id -> Varchar,
    }
}

diesel::table! {
    tracks (id) {
        #[max_length = 24]
        id -> Varchar,
        #[max_length = 255]
        title -> Varchar,
        duration_ms -> Int4,
        created_at -> Nullable<Timestamp>,
        updated_at -> Nullable<Timestamp>,
        #[max_length = 22]
        spotify_id -> Nullable<Varchar>,
        #[max_length = 10]
        tidal_id -> Nullable<Varchar>,
    }
}

diesel::table! {
    users (id) {
        #[max_length = 24]
        id -> Varchar,
        #[max_length = 255]
        name -> Varchar,
        #[max_length = 255]
        email -> Varchar,
        password -> Text,
        updated_at -> Nullable<Timestamp>,
        created_at -> Nullable<Timestamp>,
    }
}

diesel::joinable!(artists_tracks -> artists (artist_id));
diesel::joinable!(artists_tracks -> tracks (track_id));
diesel::joinable!(playlists -> users (creator_id));
diesel::joinable!(playlists_tracks -> playlists (playlist_id));
diesel::joinable!(playlists_tracks -> tracks (track_id));

diesel::allow_tables_to_appear_in_same_query!(
    artists,
    artists_tracks,
    playlists,
    playlists_tracks,
    tracks,
    users,
);
